# thinFTP

[![PyPI](https://img.shields.io/pypi/v/thinftp.svg)](https://pypi.org/project/thinftp/)
[![License](https://img.shields.io/github/license/harishtpj/thinftp.svg)](LICENSE)
[![Documentation](https://readthedocs.org/projects/thinftp/badge/?version=latest)](https://thinftp.readthedocs.io/)

> A lightweight, configurable, and fully-featured FTP server written in pure Python.

---

# ✨ Features

- 📁 **File-based backend** with root isolation
- 🔐 **User authentication** via customizable logic
- 🧵 **Multithreaded** server for concurrent clients
- 📡 Supports **PASV mode** and basic FTP commands
- ⚙️ **Extensible architecture** via handler and command hooks
- 🐍 **Python standard library only** — no dependencies

---

# 📦 Installation

```bash
pip install thinftp
```

# 🚀 Usage

For a quick FTP server on your local directory, run:

```bash
thinftp
```

for more options, run `thinftp --help`

# 📚 Documentation
Full documentation is available at [thinftp.readthedocs.io](https://thinftp.readthedocs.io/)

It includes:

- API reference
- Configuration examples

# ✍🏻 Contributing
Contributions are welcome! While the basic functionality of this project works, there is a lot of room for improvement.  If you have any suggestions or find any bugs, please [open an issue](https://github.com/harishtpj/thinftp/issues/new/choose) or [create a pull request](https://github.com/harishtpj/thinftp/pulls).

# 📝 License

#### Copyright © 2025 [M.V.Harish Kumar](https://github.com/harishtpj). <br>

#### This project is [MIT](https://github.com/harishtpj/thinftp/blob/31f6ad825cf8714c8542209f56586605c3d6c629/LICENSE) licensed.